unit fm_I332AS;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, fm_i332, StdCtrls, ExtCtrls, Buttons, ComCtrls;

type
  TfmI332AS = class(TfmI332)
    edtPos0: TLabeledEdit;
    edtPos1: TLabeledEdit;
    edtPos2: TLabeledEdit;
    edtPos3: TLabeledEdit;
    edtPos4: TLabeledEdit;
    edtPos5: TLabeledEdit;
    edtPos6: TLabeledEdit;
    edtPos7: TLabeledEdit;
    Label2: TLabel;
    edtSpeed0: TEdit;
    edtSpeed1: TEdit;
    edtSpeed2: TEdit;
    edtSpeed3: TEdit;
    edtSpeed4: TEdit;
    edtSpeed5: TEdit;
    edtSpeed6: TEdit;
    edtSpeed7: TEdit;
    Label3: TLabel;
    cbAbs0: TCheckBox;
    cbAbs1: TCheckBox;
    cbAbs2: TCheckBox;
    cbAbs3: TCheckBox;
    cbAbs4: TCheckBox;
    cbAbs5: TCheckBox;
    cbAbs6: TCheckBox;
    cbAbs7: TCheckBox;
    Label4: TLabel;
    rgVMode7: TRadioGroup;
    rgVMode6: TRadioGroup;
    rgVMode5: TRadioGroup;
    rgVMode3: TRadioGroup;
    rgVMode2: TRadioGroup;
    rgVMode1: TRadioGroup;
    cbLSOff0: TCheckBox;
    rgVMode0: TRadioGroup;
    cbPotiOff0: TCheckBox;
    cbLSOff1: TCheckBox;
    cbPotiOff1: TCheckBox;
    cbLSOff2: TCheckBox;
    cbPotiOff2: TCheckBox;
    cbLSOff3: TCheckBox;
    cbPotiOff3: TCheckBox;
    cbLSOff4: TCheckBox;
    rgVMode4: TRadioGroup;
    cbPotiOff4: TCheckBox;
    cbLSOff5: TCheckBox;
    cbPotiOff5: TCheckBox;
    cbLSOff6: TCheckBox;
    cbPotiOff6: TCheckBox;
    cbLSOff7: TCheckBox;
    cbPotiOff7: TCheckBox;
    btnAS0: TSpeedButton;
    btnAS1: TSpeedButton;
    btnAS2: TSpeedButton;
    btnAS3: TSpeedButton;
    btnAS4: TSpeedButton;
    btnAS5: TSpeedButton;
    btnAS6: TSpeedButton;
    btnAS7: TSpeedButton;
    Label5: TLabel;
    cbMod0: TComboBox;
    cbMod1: TComboBox;
    cbMod2: TComboBox;
    cbMod3: TComboBox;
    cbMod4: TComboBox;
    cbMod5: TComboBox;
    cbMod6: TComboBox;
    cbMod7: TComboBox;
    Label6: TLabel;
    Label7: TLabel;
    TrackBar1: TTrackBar;
    Label8: TLabel;
    lblJS0: TLabel;
    lblJS1: TLabel;
    lblJS2: TLabel;
    lblJS3: TLabel;
    lblJS4: TLabel;
    lblJS5: TLabel;
    lblJS6: TLabel;
    lblJS7: TLabel;
    lblADC0: TLabel;
    lblADC1: TLabel;
    lblADC2: TLabel;
    lblADC3: TLabel;
    lblADC4: TLabel;
    lblADC5: TLabel;
    lblADC6: TLabel;
    lblADC7: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    edtJS0: TEdit;
    udJS0: TUpDown;
    edtJS1: TEdit;
    udJS1: TUpDown;
    edtJS2: TEdit;
    udJS2: TUpDown;
    edtJS3: TEdit;
    udJS3: TUpDown;
    edtJS4: TEdit;
    udJS4: TUpDown;
    edtJS5: TEdit;
    udJS5: TUpDown;
    edtJS6: TEdit;
    udJS7: TUpDown;
    edtJS7: TEdit;
    udJS6: TUpDown;
    procedure btnASClick(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    constructor Create(AOwner: TComponent); override;
    PROCEDURE DoDisp; override;
  end;

var
  fmI332AS: TfmI332AS;

implementation

uses i332_def, i332_ifc; 

{$R *.dfm}

constructor TfmI332AS.Create(AOwner: TComponent);
VAR AxLbls: TAxLbls;
    i: INTEGER;
    edtPos: TLabeledEdit;
BEGIN
  inherited Create(AOwner);
  I332GetAxLabels(I332Handle,AxLbls);
  FOR i := 0 TO Axes-1 DO BEGIN
    IF FindAxComp(TComponent(edtPos),TLabeledEdit,'edtPos',i)
    THEN edtPos.EditLabel.Caption := '&'+AxLbls[i];
  END;
END;

PROCEDURE TfmI332AS.DoDisp;
VAR sfStatus: WORD;
    AchsNr: INTEGER;
    btnAS: TSpeedButton;
    AxisArray: TAxisArray;
    lblJS: TLabel;
    udJS: TUpDown;
    ADCNr: INTEGER;
    ADC: WORD;
BEGIN
  I332GetSFStatus(I332Handle,sfStatus);
  FOR AchsNr := 0 TO Axes-1 DO
  IF FindAxComp(TComponent(btnAS),TSpeedButton,'btnAS',AchsNr)
  THEN btnAS.Down := (sfStatus and (1 shl AchsNr)) <> 0;

  I332GetAxArray(I332Handle,$0093,AxisArray);
  FOR AchsNr := 0 TO  7 DO BEGIN
    IF FindAxComp(TComponent(lblJS), TLabel,'lblJS',AchsNr)
    THEN lblJS.Caption := FormatFloat('##0.0 %',SmallInt(AxisArray[AchsNr] shr 16)/32768*100);

    IF FindAxComp(TComponent(lblJS), TLabel,'lblADC',AchsNr)
    THEN BEGIN
      IF FindAxComp(TComponent(udJS),TUpDown,'udJS',AchsNr)
      THEN ADCNr := udJS.Position ELSE ADCNr := -1;

      IF (ADCNr >= 0) THEN BEGIN
        I332Read1(I332Handle,icGetADC+ADCNr,ADC);
        lblJS.Caption := IntToStr(ADC);
      END ELSE lblJS.Caption := '';
    END;
  END;
END;

procedure TfmI332AS.btnASClick(Sender: TObject);
VAR AchsNr: Byte;
    PosAsync: INTEGER;
    VAsync: LONGINT;
    sfMode: WORD;
    asAbsolute,asLSOff,asPotiOff: BOOLEAN;
    ADCNr: INTEGER;

VAR edtPos:   TLabeledEdit;
    edtSpeed: TEdit;
    rgVMode:  TRadioGroup;
    cbAS:     TCheckBox;
    cbMod:    TComboBox;
    udJS:     TUpDown;
begin
  WITH TSpeedButton(Sender) {=btnAS..} DO BEGIN
    AchsNr := StrToInt(Name[Length(Name)]);
    // Button gedrckt?
    IF NOT Down THEN BEGIN // nein: Abbruch, fertig
      I332Write1(I332Handle,icSFAsync+(AchsNr shl 8),sfBreak);
      Exit;
    END;
  END;

  //btnAS.Down = TRUE:

  // Daten aus den zugehrigen Eingabe-Elementen einsammeln...
  IF FindAxComp(TComponent(udJS),TUpDown,'udJS',AchsNr)           THEN ADCNr := udJS.Position ELSE ADCNr := -1;

  IF FindAxComp(TComponent(edtPos),TLabeledEdit,'edtPos',AchsNr)  THEN PosAsync := StrToInt(edtPos.Text);
  IF FindAxComp(TComponent(edtSpeed),TEdit,'edtSpeed',AchsNr)     THEN VAsync   := StrToInt(edtSpeed.Text);

  IF FindAxComp(TComponent(rgVMode),TRadioGroup,'rgVMode',AchsNr) THEN
  CASE rgVMode.ItemIndex OF
    0: sfMode := sfVMax;
    1: sfMode := sfVCmd;
    ELSE sfMode := sfBreak;
  END;
  IF FindAxComp(TComponent(cbAS),  TCheckBox,'cbAbs',AchsNr)     THEN asAbsolute := cbAS.Checked;
  IF FindAxComp(TComponent(cbAS),  TCheckBox,'cbLSOff',AchsNr)   THEN asLSOff    := cbAS.Checked;
  IF FindAxComp(TComponent(cbAS),  TCheckBox,'cbPotiOff',AchsNr) THEN asPotiOff  := cbAS.Checked;
  IF FindAxComp(TComponent(cbMod), TComboBox,'cbMod',AchsNr)     THEN sfMode     := sfMode or ((cbMod.ItemIndex and $03) shl 11);

  IF asAbsolute THEN sfMode := sfMode or asAbs;
  IF asLSOff    THEN sfMode := sfMode or sfLSOff;
  IF asPotiOff  THEN sfMode := sfMode or sfPotiOff;

  sfMode := ((ADCNr and $07) shl 8) or sfMode;
  IF ADCNr > 7 THEN sfMode := sfMode or $2000;

  TrackBar1Change(Sender); // 1x "ADC14" setzen, sicherheitshalber!

  // ...an die I332 bergeben:
  DispIFCErr(I332DoAxisAsync(I332Handle,AchsNr,PosAsync,VAsync,sfMode));

  // ...und Startbit setzen:
  I332ZyklusStart(I332Handle);
end;

procedure TfmI332AS.TrackBar1Change(Sender: TObject);
begin
  I332Write1(I332Handle,{icSetADC}$D810+14,TrackBar1.Position);
end;

end.
