unit fm_i332HR;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, fm_i332, StdCtrls, ExtCtrls, Buttons, ComCtrls;

type
  TfmI332HR = class(TfmI332)
    btnHR0: TSpeedButton;
    Label3: TLabel;
    Label4: TLabel;
    btnHR1: TSpeedButton;
    btnHR2: TSpeedButton;
    btnHR3: TSpeedButton;
    btnHR4: TSpeedButton;
    btnHR5: TSpeedButton;
    btnHR6: TSpeedButton;
    btnHR7: TSpeedButton;
    rgVMode7: TRadioGroup;
    rgVMode6: TRadioGroup;
    rgVMode5: TRadioGroup;
    rgVMode3: TRadioGroup;
    rgVMode2: TRadioGroup;
    rgVMode1: TRadioGroup;
    edtFeed0: TLabeledEdit;
    edtFeed1: TLabeledEdit;
    edtFeed2: TLabeledEdit;
    edtFeed3: TLabeledEdit;
    edtFeed4: TLabeledEdit;
    edtFeed5: TLabeledEdit;
    edtFeed6: TLabeledEdit;
    edtFeed7: TLabeledEdit;
    cbLSOff0: TCheckBox;
    rgVMode0: TRadioGroup;
    cbPotiOff0: TCheckBox;
    edtHR0: TEdit;
    udHR0: TUpDown;
    cbLSOff1: TCheckBox;
    cbPotiOff1: TCheckBox;
    edtHR1: TEdit;
    udHR1: TUpDown;
    cbLSOff2: TCheckBox;
    cbPotiOff2: TCheckBox;
    edtHR2: TEdit;
    udHR2: TUpDown;
    cbLSOff3: TCheckBox;
    cbPotiOff3: TCheckBox;
    edtHR3: TEdit;
    udHR3: TUpDown;
    cbLSOff4: TCheckBox;
    rgVMode4: TRadioGroup;
    cbPotiOff4: TCheckBox;
    edtHR4: TEdit;
    udHR4: TUpDown;
    cbLSOff5: TCheckBox;
    cbPotiOff5: TCheckBox;
    edtHR5: TEdit;
    udHR5: TUpDown;
    cbLSOff6: TCheckBox;
    cbPotiOff6: TCheckBox;
    edtHR6: TEdit;
    udHR6: TUpDown;
    cbLSOff7: TCheckBox;
    cbPotiOff7: TCheckBox;
    edtHR7: TEdit;
    udHR7: TUpDown;
    Label2: TLabel;
    edtDGInc0: TEdit;
    edtDGInc1: TEdit;
    edtDGInc2: TEdit;
    edtDGInc3: TEdit;
    edtDGInc4: TEdit;
    edtDGInc5: TEdit;
    edtDGInc6: TEdit;
    edtDGInc7: TEdit;
    edtDGmy0: TEdit;
    edtDGmy1: TEdit;
    edtDGmy2: TEdit;
    edtDGmy3: TEdit;
    edtDGmy4: TEdit;
    edtDGmy5: TEdit;
    edtDGmy6: TEdit;
    edtDGmy7: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    UpDown1: TUpDown;
    Label7: TLabel;
    lblDG0: TLabel;
    lblDG1: TLabel;
    lblDG2: TLabel;
    lblDG3: TLabel;
    lblDG4: TLabel;
    lblDG5: TLabel;
    lblDG6: TLabel;
    lblDG7: TLabel;
    procedure btnHRClick(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    constructor Create(AOwner: TComponent); override;
    PROCEDURE DoDisp; override;
  end;

implementation

uses i332_def, i332_ifc;

{$R *.dfm}

constructor TfmI332HR.Create(AOwner: TComponent);
VAR AxLbls: TAxLbls;
    i: INTEGER;
    edtHR: TLabeledEdit;
BEGIN
  inherited Create(AOwner);
  I332GetAxLabels(I332Handle,AxLbls);
  FOR i := 0 TO Axes-1 DO BEGIN
    IF FindAxComp(TComponent(edtHR),TLabeledEdit,'edtFeed',i)
    THEN edtHR.EditLabel.Caption := '&'+AxLbls[i];
  END;
END;

procedure TfmI332HR.btnHRClick(Sender: TObject);

VAR AchsNr: Byte;
    DGNr: INTEGER;
    VHandrad: LONGINT;
    DGmy,DGInc: LONGINT;
    sfMode: WORD;
    hrLSOff,hrPotiOff: BOOLEAN;

  PROCEDURE I332DoHR;
  BEGIN
    { (neue) Geschwindigkeit }
    I332Write2(I332Handle,icSetSFVCmd+AchsNr*256,VHandrad);

    { bersetzungsverhltnis: }
    I332Write2(I332Handle,icSetDG_my+AchsNr*256,DGmy);
    I332Write2(I332Handle,icSetDG_pls+AchsNr*256,DGInc);

    IF hrLSOff   THEN sfMode := sfMode or sfLSOff;
    IF hrPotiOff THEN sfMode := sfMode or sfPotiOff;
    sfMode := (DGNr shl 8) or sfMode;

    I332Write1(I332Handle,icSFHandrad+(AchsNr shl 8),sfMode);    { Sonderfunktion Handrad: }
  END;

VAR udHR: TUpDown;
    edtHR: TLabeledEdit;
    rgVMode: TRadioGroup;
    cbHR: TCheckBox;
begin
  WITH TSpeedButton(Sender) DO BEGIN
    AchsNr := StrToInt(Name[Length(Name)]);
    // Button gedrckt?
    IF NOT Down THEN BEGIN // nein: Abbruch, fertig
      I332Write1(I332Handle,icSFHandrad+(AchsNr shl 8),sfBreak);
      Exit;
    END;
  END;

  // btnHR.Down = TRUE:

  // Daten aus den zugehrigen Eingabe-Elementen einsammeln...
  IF FindAxComp(TComponent(udHR),TUpDown,'udHR',AchsNr) THEN DGNr := udHR.Position ELSE DGNr := -1;

  IF DGNr < 0                             // kein Drehgeber ausgewhlt:
  THEN TSpeedButton(Sender).Down := FALSE // fertig
  ELSE BEGIN
    IF FindAxComp(TComponent(edtHR),TLabeledEdit,'edtFeed',AchsNr)  THEN VHandrad := StrToInt(edtHR.Text);
    IF FindAxComp(TComponent(edtHR),TEdit,'edtDGInc',AchsNr)        THEN DGInc    := StrToInt(edtHR.Text);
    IF FindAxComp(TComponent(edtHR),TEdit,'edtDGmy',AchsNr)         THEN DGmy     := StrToInt(edtHR.Text);
    IF FindAxComp(TComponent(rgVMode),TRadioGroup,'rgVMode',AchsNr) THEN
    CASE rgVMode.ItemIndex OF
      0: sfMode := sfVMax;
      1: sfMode := sfVCmd;
      ELSE sfMode := sfBreak;
    END;
    IF FindAxComp(TComponent(cbHR), TCheckBox,'cbLSOff',AchsNr)   THEN hrLSOff   := cbHR.Checked;
    IF FindAxComp(TComponent(cbHR), TCheckBox,'cbPotiOff',AchsNr) THEN hrPotiOff := cbHR.Checked;

    // ...an die I332 bergeben:
    I332DoHR;
    // ...und Startbit setzen:
    I332ZyklusStart(I332Handle);
  END;
end;

PROCEDURE TfmI332HR.DoDisp;
VAR AchsNr: INTEGER;
    lblHR: TLabel;
    udHR: TUpDown;
    DGNr: INTEGER;
    DG: WORD;
BEGIN
  FOR AchsNr := 0 TO  7 DO BEGIN
    IF FindAxComp(TComponent(lblHR), TLabel,'lblDG',AchsNr)
    THEN BEGIN
      IF FindAxComp(TComponent(udHR),TUpDown,'udHR',AchsNr)
      THEN DGNr := udHR.Position ELSE DGNr := -1;

      IF (DGNr >= 0) THEN BEGIN
        I332Read1(I332Handle,icGetDG+DGNr,DG);
        lblHR.Caption := IntToStr(DG);
      END ELSE lblHR.Caption := '';
    END;
  END;
END;

procedure TfmI332HR.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
  I332Write1(I332Handle,$D80E,UpDown1.Position);
end;

end.
