unit fm_i332JS;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, fm_i332, StdCtrls, ExtCtrls, Buttons, ComCtrls;

type
  TfmI332JS = class(TfmI332)
    btnJS0: TSpeedButton;
    Label3: TLabel;
    Label4: TLabel;
    btnJS1: TSpeedButton;
    btnJS2: TSpeedButton;
    btnJS3: TSpeedButton;
    btnJS4: TSpeedButton;
    btnJS5: TSpeedButton;
    btnJS6: TSpeedButton;
    btnJS7: TSpeedButton;
    rgVMode7: TRadioGroup;
    rgVMode6: TRadioGroup;
    rgVMode5: TRadioGroup;
    rgVMode3: TRadioGroup;
    rgVMode2: TRadioGroup;
    rgVMode1: TRadioGroup;
    edtFeed0: TLabeledEdit;
    edtFeed1: TLabeledEdit;
    edtFeed2: TLabeledEdit;
    edtFeed3: TLabeledEdit;
    edtFeed4: TLabeledEdit;
    edtFeed5: TLabeledEdit;
    edtFeed6: TLabeledEdit;
    edtFeed7: TLabeledEdit;
    cbLSOff0: TCheckBox;
    rgVMode0: TRadioGroup;
    cbPotiOff0: TCheckBox;
    edtJS0: TEdit;
    udJS0: TUpDown;
    cbLSOff1: TCheckBox;
    cbPotiOff1: TCheckBox;
    edtJS1: TEdit;
    udJS1: TUpDown;
    cbLSOff2: TCheckBox;
    cbPotiOff2: TCheckBox;
    edtJS2: TEdit;
    udJS2: TUpDown;
    cbLSOff3: TCheckBox;
    cbPotiOff3: TCheckBox;
    edtJS3: TEdit;
    udJS3: TUpDown;
    cbLSOff4: TCheckBox;
    rgVMode4: TRadioGroup;
    cbPotiOff4: TCheckBox;
    edtJS4: TEdit;
    udJS4: TUpDown;
    cbLSOff5: TCheckBox;
    cbPotiOff5: TCheckBox;
    edtJS5: TEdit;
    udJS5: TUpDown;
    cbLSOff6: TCheckBox;
    cbPotiOff6: TCheckBox;
    edtJS6: TEdit;
    udJS6: TUpDown;
    cbLSOff7: TCheckBox;
    cbPotiOff7: TCheckBox;
    edtJS7: TEdit;
    udJS7: TUpDown;
    Label2: TLabel;
    Label5: TLabel;
    lblJS0: TLabel;
    lblJS1: TLabel;
    lblJS2: TLabel;
    lblJS3: TLabel;
    lblJS4: TLabel;
    lblJS5: TLabel;
    lblJS6: TLabel;
    lblJS7: TLabel;
    lblADC0: TLabel;
    lblADC1: TLabel;
    lblADC2: TLabel;
    lblADC3: TLabel;
    lblADC4: TLabel;
    lblADC5: TLabel;
    lblADC6: TLabel;
    lblADC7: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    TrackBar1: TTrackBar;
    procedure btnJSClick(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    constructor Create(AOwner: TComponent); override;
    PROCEDURE DoDisp; override;
  end;

implementation

uses i332_def, i332_ifc;

{$R *.dfm}

constructor TfmI332JS.Create(AOwner: TComponent);
VAR AxLbls: TAxLbls;
    i: INTEGER;
    edtJS: TLabeledEdit;
BEGIN
  inherited Create(AOwner);
  I332GetAxLabels(I332Handle,AxLbls);
  FOR i := 0 TO Axes-1 DO BEGIN
    IF FindAxComp(TComponent(edtJS),TLabeledEdit,'edtFeed',i)
    THEN edtJS.EditLabel.Caption := '&'+AxLbls[i];
  END;
END;

procedure TfmI332JS.btnJSClick(Sender: TObject);

VAR AchsNr: Byte;
    ADCNr: INTEGER;
    VJoyStick: LONGINT;
    sfMode: WORD;
    jsLSOff,jsPotiOff: BOOLEAN;

  PROCEDURE I332DoJS;
  BEGIN
    I332Write2(I332Handle,icSetSFVCmd+AchsNr*256,VJoystick);   { (neue) Geschwindigkeit }
    IF jsLSOff   THEN sfMode := sfMode or sfLSOff;
    IF jsPotiOff THEN sfMode := sfMode or sfPotiOff;
    sfMode := (ADCNr shl 8) or sfMode;
    I332Write1(I332Handle,icSFJoystick+(AchsNr shl 8),sfMode); { Joystick }
  END;

VAR udJS: TUpDown;
    edtJS: TLabeledEdit;
    rgVMode: TRadioGroup;
    cbJS: TCheckBox;
begin
  WITH TSpeedButton(Sender) DO BEGIN
    AchsNr := StrToInt(Name[Length(Name)]);
    // Button gedrckt?
    IF NOT Down THEN BEGIN // nein: Abbruch, fertig
      I332Write1(I332Handle,icSFJoystick+(AchsNr shl 8),sfBreak);
      Exit;
    END;
  END;

  // btnJS.Down = TRUE:

  // Daten aus den zugehrigen Eingabe-Elementen einsammeln...
  IF FindAxComp(TComponent(udJS),TUpDown,'udJS',AchsNr)           THEN ADCNr := udJS.Position ELSE ADCNr := -1;

  IF ADCNr < 0                             // kein AD-Eingang ausgewhlt:
  THEN TSpeedButton(Sender).Down := FALSE  // fertig
  ELSE BEGIN
    IF FindAxComp(TComponent(edtJS),TLabeledEdit,'edtFeed',AchsNr)  THEN VJoyStick := StrToInt(edtJS.Text);
    IF FindAxComp(TComponent(rgVMode),TRadioGroup,'rgVMode',AchsNr) THEN
    CASE rgVMode.ItemIndex OF
      0: sfMode := sfVMax;
      1: sfMode := sfVCmd;
      ELSE sfMode := sfBreak;
    END;
    IF FindAxComp(TComponent(cbJS), TCheckBox,'cbLSOff',AchsNr)   THEN jsLSOff   := cbJS.Checked;
    IF FindAxComp(TComponent(cbJS), TCheckBox,'cbPotiOff',AchsNr) THEN jsPotiOff := cbJS.Checked;

    TrackBar1Change(Sender); // 1x "ADC14" setzen, sicherheitshalber!

    // ...an die I332 bergeben:
    I332DoJS;
    // ...und Startbit setzen:
    I332ZyklusStart(I332Handle);
  END;
end;

PROCEDURE TfmI332JS.DoDisp;
VAR AchsNr: INTEGER;
    AxisArray: TAxisArray;
    lblJS: TLabel;
    udJS: TUpDown;
    ADCNr: INTEGER;
    ADC: WORD;
BEGIN
  I332GetAxArray(I332Handle,$0093,AxisArray);
  FOR AchsNr := 0 TO  7 DO BEGIN
    IF FindAxComp(TComponent(lblJS), TLabel,'lblJS',AchsNr)
    THEN lblJS.Caption := FormatFloat('##0.0 %',SmallInt(AxisArray[AchsNr] shr 16)/32768*100);

    IF FindAxComp(TComponent(lblJS), TLabel,'lblADC',AchsNr)
    THEN BEGIN
      IF FindAxComp(TComponent(udJS),TUpDown,'udJS',AchsNr)
      THEN ADCNr := udJS.Position ELSE ADCNr := -1;

      IF (ADCNr >= 0) THEN BEGIN
        I332Read1(I332Handle,icGetADC+ADCNr,ADC);
        lblJS.Caption := IntToStr(ADC);
      END ELSE lblJS.Caption := '';
    END;  
  END;
END;

procedure TfmI332JS.TrackBar1Change(Sender: TObject);
begin
  I332Write1(I332Handle,{icSetADC}$D810+14,TrackBar1.Position);
end;

end.
