unit fm_i332Ref;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, fm_i332, ComCtrls;

type
  TfmI332Ref = class(TfmI332)
    btnRef3: TSpeedButton;
    btnRef2: TSpeedButton;
    btnRef4: TSpeedButton;
    btnRef5: TSpeedButton;
    btnRef6: TSpeedButton;
    btnRef7: TSpeedButton;
    btnRef0: TSpeedButton;
    lblRef0: TLabel;
    lblRef1: TLabel;
    lblRef3: TLabel;
    lblRef2: TLabel;
    lblRef7: TLabel;
    lblRef6: TLabel;
    lblRef5: TLabel;
    lblRef4: TLabel;
    btnRef1: TSpeedButton;
    procedure btnRefClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    constructor Create(AOwner: TComponent); override;
    PROCEDURE DoDisp; override;
  end;

implementation

uses i332_def, i332_ifc;

{$R *.dfm}

constructor TfmI332Ref.Create(AOwner: TComponent);
VAR AxLbls: TAxLbls;
    i: INTEGER;
    btnRef: TSpeedButton;
BEGIN
  inherited Create(AOwner);
  I332GetAxLabels(I332Handle,AxLbls);
  FOR i := 0 TO Axes-1 DO BEGIN
    IF FindAxComp(TComponent(btnRef),TSpeedButton,'btnRef',i)
    THEN btnRef.Caption := '&'+AxLbls[i];
  END;
END;

procedure TfmI332Ref.btnRefClick(Sender: TObject);
VAR Axis: INTEGER;
begin
  try
    WITH TSpeedButton(Sender) DO Axis := StrToInt(Name[Length(Name)]);
    I332DoAxisRef(I332Handle,Axis);
    I332ZyklusStart(I332Handle);
  except
  end;
end;

PROCEDURE TfmI332Ref.DoDisp;
VAR refInfo: WORD;
    i: INTEGER;
    lblRef: TLabel;
BEGIN
  I332GetRefInfo(I332Handle,refInfo);
  FOR i := 0 TO Axes-1 DO BEGIN
    IF FindAxComp(TComponent(lblRef),TLabel,'lblRef',i)
    THEN BEGIN
      IF (refInfo and (1 shl i) <> 0) THEN BEGIN
        lblRef.Caption := 'Achse referenziert';
        lblRef.Color := clLime;
      END ELSE BEGIN
        lblRef.Caption := 'Achse nicht referenziert';
        lblRef.Color := clRed;
      END;
    END;
  END;
END;

end.
