unit fm_I332CNC;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, fm_i332, StdCtrls, ComCtrls, i332_cnc, Buttons;

type
  TfmI332CNC = class(TfmI332)
    edtCNC: TEdit;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private-Deklarationen }
    I332CNC: TI332CNC;
    I332Thread: TI332Thread;
  public
    { Public-Deklarationen }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  end;

implementation

uses WinUtils;

{$R *.dfm}

constructor TfmI332CNC.Create(AOwner: TComponent);
BEGIN
  inherited Create(AOwner);
  I332CNC := TI332CNC.Create(I332Handle);
END;

destructor TfmI332CNC.Destroy;
BEGIN
  FreeObj(I332Thread);
  I332CNC.Free;
  inherited Destroy;
END;

procedure TfmI332CNC.BitBtn1Click(Sender: TObject);
begin
  I332CNC.ScanLine(edtCNC.Text);
  I332CNC.UpdateI332;
end;

procedure TfmI332CNC.BitBtn2Click(Sender: TObject);
begin
  IF NOT Assigned(I332Thread)
  THEN I332Thread := TI332Thread.Create(I332CNC)
  ELSE I332Thread.Restart(FALSE);
end;

end.
