unit fm_I332SP;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, fm_i332, StdCtrls, Buttons, ExtCtrls, ComCtrls;

type
  TfmI332SP = class(TfmI332)
    btnIPL: TBitBtn;
    edtDelay: TLabeledEdit;
    edtSpeed: TLabeledEdit;
    rgBeg: TRadioGroup;
    rgEnd: TRadioGroup;
    Label2: TLabel;
    procedure btnIPLClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

implementation

uses i332_def, i332_ifc;

{$R *.dfm}

procedure TfmI332SP.btnIPLClick(Sender: TObject);
// Spindel-Drehzahl setzen
// Damit dieses Beispiel funktioniert ist folgendes zu beachten:
// - Die Spindel mu im Konfigurationsdialog korrekt definiert werden
// - fr die Spindel-Ausgnge wird vom Konfig.-Dialog das entsprechende
//   Bit im Register mpXXXOutPAR = 0 gesetzt; dies sollte nicht gendert werden!!
// sonstiges:
// - Drehzahl ist modal, d.h. mu nur einmal bergeben werden
// - Drehzahl wird IMMER am Satzanfang gesetzt
// - die Spindel-Ausgnge (M03/M04/M05) dagegen je nach Programmierung:
VAR S,T,m: LONGINT;
begin
  S := StrToInt(edtSpeed.Text);
  T := StrToInt(edtDelay.Text);
  m := 0;
  CASE rgBeg.ItemIndex OF
    1: m := m + m05Beg;
    2: m := m + m03Beg;
    3: m := m + m04Beg;
  END;
  CASE rgEnd.ItemIndex OF
    1: m := m + m05End;
    2: m := m + m03End;
    3: m := m + m04End;
  END;

  I332Write2(I332Handle,icSetSCmd,S);       // Spindeldrehzahl setzen
  I332Write2(I332Handle,icSetStdM,m);       // Spindel-Ports setzen
  DispIFCErr(I332DoDelay(I332Handle,T,0));  // Wartezeit
end;

end.
